<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "DTD/xhtml1-transitional.dtd">

<!--
Copyright 2007, Google Inc.

Redistribution and use in source and binary forms, with or without 
modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, 
    this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. Neither the name of Google Inc. nor the names of its contributors may be
    used to endorse or promote products derived from this software without
    specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-->

<html>
  <head>
    <title>Tutorial</title>
    <link rel="stylesheet" type="text/css" href="gears.css" />
  </head>

<body>

<h1>Tutorial</h1>

<div id="pagecontent">

<p>Any static HTML files, such as  documentation, can be enabled for viewing  offline by following these steps. This tutorial shows you how to create  a manifest file, and make your files  available  offline, using Gears. (Time estimate: 15 minutes.) </p>
<h4>You will need:</h4>
<ul>
  <li>Ability to edit basic JavaScript </li>
  <li>Ability to publish files to the HTTP server that hosts your files</li>
  <li>The static files that you want to enable for offline viewing</li>
  <li>For a list of supported browsers and platforms, see <a href="http://gears.google.com/">gears.google.com</a>.  </li>
</ul>
<h4>Files to download for this tutorial: </h4>
<ul><li><a href="tutorials/tutorial_manifest.json">tutorial_manifest.json</a></li>
  <li><a href="tutorials/go_offline.html">go_offline.html</a></li>
  <li><a href="tutorials/go_offline.js">go_offline.js</a></li>
  <li><a href="gears_init.js">gears_init.js</a></li>
</ul>
<h1>1. Edit the sample manifest file </h1>
<h3>Save this <a href="tutorials/tutorial_manifest.json">tutorial manifest file</a> to your computer. </h3>
<ul>
  <li>Rename it &quot;manifest.json&quot;. </li>
  <li>Open your <strong>manifest.json</strong> in an editor.</li>
</ul>
<h3>Edit the version value </h3>
<p>The manifest file contains a series of attribute-value pairs. </p>
<ul>
  <li> Replace <code>&quot;my_version_string&quot;</code> value with a version string that is meaningful to you. This value represents the version of your documents. Example: &quot;version 1.0&quot;. </li>
</ul>
<p>You will update this version string in the future to indicate that there is a change in any of your documents.</p>
<h3>Edit the URLs </h3>
<p>The &quot;entries&quot; attribute contains an array of URLs that you wish to capture and have available offline. </p>
<ul>
  <li>For every file and image that you wish to capture, add a <code>&quot;url&quot;</code> entry into the <code>&quot;entries&quot;</code> array. Follow the format in the sample manifest file.</li>
  <li>Check that each entry except for the last one is followed by a comma. </li>
  <li>To have the tutorial's &quot;go_offline&quot; files available offline too, include them in the manifest. </li>
</ul>
<p>For example, if your documentation consists of an index.html page, a stylesheet style.css,  and a logo in the file resources/logo.gif in addition to the tutorial's files, you will have the following <code>&quot;url&quot;</code> entries:</p>
<pre><code>&quot;entries&quot;: [
    { &quot;url&quot;: &quot;index.html&quot; },
    { &quot;url&quot;: &quot;style.css&quot; },
    { &quot;url&quot;: &quot;resources/logo.gif&quot; },
    { &quot;url&quot;: &quot;gears_init.js&quot;},
    { &quot;url&quot;: &quot;go_offline.html&quot;},
    { &quot;url&quot;: &quot;go_offline.js&quot;}
] </code></pre>
<p><strong>Note</strong>: The    URLs can be fully-qualified, for example &quot;http://www.example.com/index.html&quot;, or they can be relative to the manifest file's location.</p>
<h1>2. Add some User Interface </h1>
<p>Some basic user interface is needed to provide a way for your user to request the offline functionality. </p>
<h4>Download and save these  files to your computer:</h4>
<p><a href="tutorials/go_offline.html">go_offline.html</a> - user interface sample <br />
  <a href="tutorials/go_offline.js">go_offline.js</a><br />
  <a href="gears_init.js">gears_init.js</a> - provides access to Google Gears. </p>
<p><strong><em>Special note:</em></strong> To keep this tutorial simple, the go_offline.html file is provided  to act as the user interface.</p>
<p>You are not limited to using the provided file; you can  integrate the functionality provided in the go_offline.js JavaScript file into your application in other ways. </p>
<p>Keep in mind that  the user will need to:</p>
<ul>
  <li>Install Gears</li>
  <li>Allow your website to use Gears (a permissions dialog appears automatically) </li>
  <li>Enable the offline version of your documents </li>
</ul>
<h1>3. Upload files to your HTTP server </h1>
<h4>Upload all the files and your documents to your HTTP server. </h4>
<ul>
  <li>go_offline.html</li>
  <li>go_offline.js</li>
  <li>gears_init.js</li>
  <li>manifest.json</li>
  <li>All the files listed in your manifest.json file.</li>
</ul>
<p><strong>Important:</strong> Be sure all the files listed in the manifest file are available and accessible as listed. </p>
<h1>4. Test: capture the files locally </h1>
<p>In the testing steps, you act as the user. </p>
<ul><li>If you haven't already, <a href="install.html">install Gears</a> on your computer. </li>
  <li>In your browser, type the URL of the go_offline.html page on your HTTP server
  </li>
  <ul>
    <li>For example: http://www.example.com/go_offline.html</li>
      </ul>
  <li>Click Capture. A status message  appears when the file capture is complete.</li>
  </ul>
<h1>5. Test: access the captured files </h1>
<ul>
  <li>Take your browser offline. Select File &gt; Work Offline. </li>
  <li>Clear your browser cache. In Firefox, select Tools &gt; Clear Private Data...,  check Cache, and click the &quot;Clear Private Data Now&quot; button. </li>
  <li>Type the URL of your document.
    <ul>
      <li>If the offline capture is in effect, you will see your stored document.</li>
      <li>If the offline capture is not in effect, you will see a browser error message</li>
      </ul>
  </li>
  </ul>
<p>Clear your browser cache often while testing, to prevent seeing cached (but not necessarily offline-enabled) content. </p>
<h3>Troubleshooting</h3>
<ul>
  <li>Make sure you have installed Google Gears. </li>
  <li>All the URLs in the manifest file must be correct, and reachable from the directory that the manifest resides in. The manifest file and the URLs it references must be located in the same domain.  </li>
  <li>Check  that there aren't any typos or extraneous files listed in the manifest.</li>
  <li>The  code in <strong>go_offline.js</strong> expects that the manifest file is named &quot;manifest.json&quot; and that it resides in the same directory. Update the manifest.json references in go_offline.js as needed. </li>
  <li>Use a JavaScript debugger to see any errors that may be returned from the Gears API calls. </li>
  </ul>
<h1>6. Publish it to your users</h1>
<p>Your users can now access your documents offline by following the  instructions in Step 4 above.</p>
<h1>7. Future changes: maintaining the manifest </h1>
<p>Whenever you update the contents in the static HTML files, or if you add or remove  files, you must update the manifest file. When Google Gears detects a new manifest version string, the updated contents are automatically copied to your user's local machine when they next view any of your files. </p>
<ul>
  <li>Always update the version string in the manifest file to indicate any changes. </li>
  <li>Update the manifest entries to correspond to any added or removed files.</li>
  <li>If you change just the content in the files, you need only to update the version string in the manifest file.</li>
</ul>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p>For more information on the manifest file or the APIs used in this tutorial, see the <a href="api_localserver.html">LocalServer API Reference</a>. </p>


</div>
</body>
</html>
